/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.bootablejar.rest;

import io.swagger.v3.jaxrs2.integration.JaxrsOpenApiContextBuilder;
import io.swagger.v3.jaxrs2.integration.resources.OpenApiResource;
import io.swagger.v3.oas.annotations.OpenAPIDefinition;
import io.swagger.v3.oas.annotations.servers.Server;
import io.swagger.v3.oas.integration.OpenApiConfigurationException;
import io.swagger.v3.oas.integration.SwaggerConfiguration;
import io.swagger.v3.oas.models.OpenAPI;
import io.swagger.v3.oas.models.info.Info;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import javax.servlet.ServletConfig;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;

/**
 *
 * @author rickyepoderi
 *
 * CREATE DATABASE test CHARACTER SET utf8 COLLATE utf8_general_ci;
 * create user 'test'@'localhost' IDENTIFIED BY 'password';
 * grant all on test.* to 'test'@'localhost';
 * module add --name=org.mariadb --resources=/path/to/mariadb-java-client-2.7.2.jar --dependencies=javax.api,javax.transaction.api
 * /subsystem=datasources/jdbc-driver=mariadb:add(driver-name=mariadb, driver-module-name=org.mariadb, driver-xa-datasource-class-name=org.mariadb.jdbc.MySQLDataSource)
 * data-source add --name=MariaDBDS --jndi-name=java:jboss/MariaDBDS --driver-name=mariadb --connection-url=jdbc:mariadb://localhost:3306/test --user-name=test --password=password --validate-on-match=true --background-validation=false --valid-connection-checker-class-name=org.jboss.jca.adapters.jdbc.extensions.mysql.MySQLValidConnectionChecker --exception-sorter-class-name=org.jboss.jca.adapters.jdbc.extensions.mysql.MySQLExceptionSorter
 */
@ApplicationPath("api")
@OpenAPIDefinition(servers = @Server(url="/"))
public class RestApplication extends Application {

    @Context
    private ServletConfig servletConfig;

    public RestApplication() {
        try {
            new JaxrsOpenApiContextBuilder()
                    .servletConfig(servletConfig)
                    .application(this)
                    .openApiConfiguration(new SwaggerConfiguration()
                            .openAPI(new OpenAPI()
                                    .info(new Info()
                                            .title("User Endpoint")
                                            .description("Sample Bootable JAR using MariaDB")
                                            .version("0.0.1-SNAPSHOT")))
                            .prettyPrint(true)
                            .resourcePackages(Collections.singleton(UserEndpoint.class.getPackage().getName())))
                    .buildContext(true);
        } catch (OpenApiConfigurationException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public Set<Class<?>> getClasses() {
        Set<Class<?>> classes = new HashSet<>();
        classes.add(UserEndpoint.class);
        classes.add(OpenApiResource.class);
        return classes;
    }
}
